<?php

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

$baseDir = dirname(__DIR__);
require_once $baseDir.'/notification.mastermatka.com/fpm/vendor/autoload.php';

use GuzzleHttp\Client;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Exception\RequestException;
use Plokko\Firebase\FCM\Exceptions\FcmErrorException;
use Plokko\Firebase\FCM\Message;
use Plokko\Firebase\FCM\Request;
use Plokko\Firebase\FCM\Targets\Topic;
use Plokko\Firebase\ServiceAccount;


 $token = md5(date('d/m/y H').'app_notification');

if(isset($_REQUEST['send_notification']) && (isset($_REQUEST['token']))){
    
    $topicName = $_REQUEST['topic'];
    $title = $_REQUEST['title'];
    $body = $_REQUEST['body'];
    $data = [
        'title' => $title,
        'body' => $body
    ];
    
    
    
    sendFCMNotification($topicName, $title, $body, $data = []);
    
}


function sendFCMNotification($topicName, $title, $body, $data = [])
{
    global $baseDir;

    // Service account credential file
    $serviceCredentials = $baseDir.'/notification.mastermatka.com/serviceAccountCredentials.json';

    // Init the service account
    $sa = new ServiceAccount($serviceCredentials);
    
 // Create a new FCM message
    $message = new Message();

     $data['message'] = $body;
     $data['title'] = $title;
    
    // Add a notification
     $message->data->fill([
        'title' => $title,
        'body' => $body,
        'vibrate' => 1,
        'sound' => 1,
    ]);

    // Add data payload
    $message->data->fill($data);

    // Device specific configuration
    $message->android->ttl = '10.4s';
    $message->android->setPriorityHigh();
    $message->android->data->fill(['android-specific'=>'data']);

    // Set the target
    $target = new Topic($topicName);
    $message->setTarget($target);

    // Submit the message
    $client = new Client(['debug' => false]);
    $validate_only = false;
    $rq = new Request($sa, $validate_only, $client);

    try {
        // Use the request to submit the message
        $message->send($rq);
      //  echo "Message sent successfully to topic $topicName.";
    } catch (FcmErrorException $e) {
    //    echo 'FCM error [' . $e->getErrorCode() . ']: ' . $e->getMessage();
    } catch (RequestException $e) {
       // $response = $e->getResponse();
   //     echo 'Got an HTTP response error: ' . $response->getStatusCode() . ': ' . $response->getReasonPhrase();
    } catch (GuzzleException $e) {
     //   echo 'Got an HTTP error: ' . $e->getMessage();
    }
}
